Attribute VB_Name = "modComms"
Option Explicit

Dim ComPort As Integer
Dim Counter As Integer
Dim ComTemp As Integer

Dim BaudrateCopy As String
Dim ParityCopy As String
Dim DatabitsCopy As String
Dim StopBitsCopy As String

Public Sub CommScan(ComPortCombo As ComboBox, CommControl As MSComm, Optional PortNumber As String)
For Counter = 0 To ComPortCombo.ListCount - 1
    ComPortCombo.RemoveItem 0 'Remove first item in list
Next Counter
If CommControl.PortOpen = True Then
    CommControl.PortOpen = False
    ComTemp = CommControl.CommPort 'Port was open, so save current portnumber
End If

If PortNumber <> "" Then
    PortNumber = Replace(UCase(PortNumber), "COM", "", , , vbTextCompare)
    ComTemp = Val(PortNumber)
End If

CommControl.Settings = "9600,n,8,1"
Counter = 0
For ComPort = 1 To 16 'Scan ports
    CommControl.CommPort = ComPort
    On Error Resume Next
    CommControl.PortOpen = True 'If port doesn't exist, it will fail here
    If CommControl.PortOpen = True Then 'No failure, add to list
        ComPortCombo.List(Counter) = "Com" & ComPort & ":"
        ComPortCombo.ItemData(Counter) = ComPort
        Counter = Counter + 1
    End If
    CommControl.PortOpen = False
Next ComPort
ComPortCombo.Text = ComPortCombo.List(0) 'Set first available port
CommControl.CommPort = ComPortCombo.ItemData(0)
For ComPort = 0 To Counter - 1
    If ComPortCombo.ItemData(ComPort) = ComTemp Then 'Restore previous port, if still available
        ComPortCombo.Text = ComPortCombo.List(ComPort)
        CommControl.CommPort = ComPortCombo.ItemData(ComPort)
        Exit For
    End If
Next ComPort
If CommControl.PortOpen = True Then CommControl.PortOpen = False
SetComms CommControl
End Sub

Public Sub ChangeComms(ComPortCombo As ComboBox, CommControl As MSComm)
If CommControl.PortOpen = True Then CommControl.PortOpen = False
CommControl.CommPort = ComPortCombo.ItemData(ComPortCombo.ListIndex)
SetComms CommControl
End Sub

Public Function SetComms(CommControl As MSComm, Optional Baudrate As String, Optional Databits As String, Optional Parity As String, Optional StopBits As String) As Boolean
If Baudrate = "" Then Baudrate = BaudrateCopy
If Databits = "" Then Databits = DatabitsCopy
If Parity = "" Then Parity = ParityCopy
If StopBits = "" Then StopBits = StopBitsCopy

Baudrate = Val(Baudrate)
Databits = Val(Databits)

If Val(Baudrate) = 0 Then Baudrate = "9600"
If Val(Databits) < 5 Then Databits = "8"
If Val(Databits) > 8 Then Databits = "8"

Parity = LCase(Left(Parity, 1))

Select Case Parity
    Case "n", "e", "o", "m", "s"
    Case Else
        Parity = "n"
End Select

If StopBits = "1.5" Or StopBits = "1,5" Or StopBits = "2" Then
    If Val(Databits) = 5 Then
        StopBits = "1.5"
    Else
        StopBits = "2"
    End If
Else
    StopBits = "1"
End If

BaudrateCopy = Baudrate
DatabitsCopy = Databits
ParityCopy = Parity
StopBitsCopy = StopBits

If CommControl.Settings = Baudrate & "," & Parity & "," & Databits & "," & StopBits And CommControl.PortOpen = True Then 'nothing changed
    SetComms = True
    Exit Function
End If

If CommControl.PortOpen = True Then CommControl.PortOpen = False

On Error GoTo ErrorHandler
CommControl.Settings = Baudrate & "," & Parity & "," & Databits & "," & StopBits
On Error Resume Next
CommControl.PortOpen = True
If CommControl.PortOpen = False Then
    SetComms = False
Else
    SetComms = True
End If
Exit Function

ErrorHandler:
SetComms = False
End Function
